package org.example.blyskawica;

public class Gra {

    private final int stawka;
    private final Gracz[] gracze;
    private Talia talia;

    private int numerRozdania = 1;

    public Gra(int stawka, Gracz[] gracze) {
        this.stawka = stawka;
        this.gracze = gracze;
    }

    public boolean symulujRozdanie() {
        for (Gracz gracz : gracze) {
            if (gracz.czyRezygnuje(stawka)) {
                return false;
            }
        }

        talia = new Talia();
        talia.tasuj();

        int pula = 0;
        for (Gracz gracz : gracze)
            pula += gracz.noweRozdanie(stawka);

        for (int i = 0; i < 5; i++) {
            for (Gracz gracz : gracze) {
                gracz.otrzymajKarte(talia.dajKarte());
            }
        }

        Gracz kandydat = null;
        for (Gracz gracz : gracze) {
            if (kandydat == null || gracz.dajNajstarsza().lepszaOd(kandydat.dajNajstarsza())) {
                kandydat = gracz;
            }
        }

        kandydat.wygranko(pula);

        wypiszRaport(kandydat);

        numerRozdania++;
        return true;
    }

    private void wypiszRaport(Gracz kandydat) {
        System.out.println("Rozdanie numer " + numerRozdania + " wygrał gracz " + kandydat.dajImie());
        for (Gracz gracz : gracze)
            gracz.wypiszKarty();
    }
}
