package org.example.bst;

public class InnerNode<T extends Comparable<T>> extends Node<T> {

    private Node<T> left, right;

    private final T value;

    public InnerNode(Node<T> left, Node<T> right, T value) {
        this.left = left;
        this.right = right;
        this.value = value;
    }


    @Override
    public Node<T> add(T value) {
        int compare = this.value.compareTo(value);
        if (compare < 0)
            left = left.add(value);
        else if (compare > 0)
            right = right.add(value);
        return this;
    }

    @Override
    public boolean contains(T value) {
        int compare = this.value.compareTo(value);
        if (compare == 0)
            return true;
        else if (compare < 0)
            return left.contains(value);
        else
            return right.contains(value);
    }

    @Override
    public boolean empty() {
        return false;
    }

    @Override
    public void execute(Operation<T> operation) {
        left.execute(operation);
        operation.apply(value);
        right.execute(operation);
    }
}
