package org.example.bst;

import java.util.Comparator;

public class Point2D implements Comparable<Point2D> {

    private final double x, y;

    public Point2D(double x, double y) {
        this.x = x;
        this.y = y;
    }

    @Override
    public int compareTo(Point2D o) {
        return Comparator
                .comparingDouble(Point2D::getX)
                .thenComparingDouble(Point2D::getY)
                .compare(this, o);
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }
}
