package org.example.stack;

public class Stack<T> implements IStack<T> {

    private final T[] data;
    private int top_index = 0;

    public Stack(T[] data) {
        this.data = data;
    }

    @Override
    public void push(T x) throws StackFullException {
        if (top_index == data.length)
            throw new StackFullException();
        data[top_index++] = x;
    }

    @Override
    public T pop() throws StackEmptyException {
        if (top_index == 0)
            throw new StackEmptyException();
        return data[--top_index];
    }

    @Override
    public T peek() throws StackEmptyException {
        if (top_index == 0)
            throw new StackEmptyException();
        return data[top_index - 1];
    }

    @Override
    public int size() {
        return top_index;
    }

    @Override
    public boolean empty() {
        return top_index == 0;
    }

    @Override
    public void clear() {
        top_index = 0;
    }
}